// Michael J. Wilson
// Music 256a Fall 2010
// Homework #2

#ifndef __UNITDELAYFEEDBACK_H__
#define __UNITDELAYFEEDBACK_H__

#include "UnitDelay.h"
#include <vector>

/// Basic sine wave
class UnitDelayFeedback : public UnitDelay
{
public:
    /// Destructor
    virtual ~UnitDelayFeedback();

    /// Constructor
    UnitDelayFeedback(size_t delay = 0, double attenuation = 0.0);

    /// Get the sample at the specified time and sample offset
    virtual double get_next_sample(double* input_sample = NULL);

protected:
    /// Feedback attenuation factor
    double m_attenuation;
};

#endif
